#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%global		debug_package	%{nil}
%define		sname	clc
#-----------------------------------------------------------------------------
Name		:	libclc
Version		:	18.1.7
Release		:	17.0.10.rel%{?dist}
Summary		:	An open source implementation of the OpenCL 1.1 library requirements
 

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	Apache-2.0 or MIT
URL		:	https://libclc.llvm.org
			#https://github.com/llvm/llvm-project/

Source0		:	%{name}-%{version}.src.tar.xz

#-----------------------------------------------------------------------------
BuildRequires	:	llvm-clang
BuildRequires	:	cmake
BuildRequires	:	libedit-devel
BuildRequires	:	llvm-devel
BuildRequires	:	SPIRV-LLVM-Translator-tools
BuildRequires	:	SPIRV-LLVM-Translator-devel

#-----------------------------------------------------------------------------
%description
libclc is an open source, BSD licensed implementation of the library
requirements of the OpenCL C programming language, as specified by the
OpenCL 1.1 Specification. The following sections of the specification
impose library requirements:
 
  * 6.1: Supported Data Types
  * 6.2.3: Explicit Conversions
  * 6.2.4.2: Reinterpreting Types Using as_type() and as_typen()
  * 6.9: Preprocessor Directives and Macros
  * 6.11: Built-in Functionsj
  * 9.3: Double Precision Floating-Point
  * 9.4: 64-bit Atomics
  * 9.5: Writing to 3D image memory objects
  * 9.6: Half Precision Floating-Point
 
libclc is intended to be used with the Clang compiler's OpenCL frontend.
 
libclc is designed to be portable and extensible. To this end, it provides
generic implementations of most library requirements, allowing the target
to override the generic implementation at the granularity of individual
functions.
 
libclc currently only supports the PTX target, but support for more
targets is welcome.

#-----------------------------------------------------------------------------
%files
%defattr(-,root,root,-)
%license LICENSE.TXT
%doc README.TXT CREDITS.TXT
%{_datadir}/%{sname}/*.bc
%{_datadir}/%{sname}/spirv-mesa3d-.spv
%{_datadir}/%{sname}/spirv64-mesa3d-.spv

#=============================================================================
%package		devel
Summary		:	Development files for %{name}

#-----------------------------------------------------------------------------
Requires	:	%{name}		= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains libraries and
header files for developing applications that
use %{name}.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%doc README.TXT CREDITS.TXT
%{_includedir}/%{sname}/*.h
%{_includedir}/%{sname}/atom_decl_int32.inc
%{_includedir}/%{sname}/atom_decl_int64.inc
%{_includedir}/%{sname}/*/*.inc
%{_includedir}/%{sname}/async/*.h
%{_includedir}/%{sname}/atomic/*.h
%{_includedir}/%{sname}/cl_khr_*/*.h
%{_includedir}/%{sname}/common/*.h
%{_includedir}/%{sname}/explicit_fence/explicit_memory_fence.h
%{_includedir}/%{sname}/float/*.h
%{_includedir}/%{sname}/geometric/*.h
%{_includedir}/%{sname}/image/*.h
%{_includedir}/%{sname}/integer/*.h
%{_includedir}/%{sname}/math/*.h
%{_includedir}/%{sname}/misc/*.h
%{_includedir}/%{sname}/relational/*.h
%{_includedir}/%{sname}/shared/*.h
%{_includedir}/%{sname}/synchronization/*.h
%{_includedir}/%{sname}/workitem/*.h
%{_datadir}/pkgconfig/%{name}.pc

#=============================================================================
%prep
%setup -q -n %{name}-%{version}.src

#-----------------------------------------------------------------------------
#building application
%build

cmake							\
	-B _bld						\
	-S .						\
	-G Ninja					\
	-D CMAKE_BUILD_TYPE=Release 			\
	-D CMAKE_INSTALL_PREFIX=%{_prefix}		\
	-D BUILD_SHARED_LIBS=ON				\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
cmake							\
	--build						\
	_bld						\
	%{_smp_mflags}					\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
%check

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

DESTDIR=%{buildroot}					\
	cmake						\
	--install					\
	_bld

#-----------------------------------------------------------------------------
%changelog
